'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});


var Mixed = { type: 'mixed' };
/* eslint-disable no-use-before-define */

var Boolean = { type: 'boolean' };
var Null = { type: 'null' };
var Number = { type: 'number' };
var String = { type: 'string' };

var Declaration = function Declaration(name, value) {
  return { type: 'declaration', name: name, value: value };
};
var Type = function Type(name, value) {
  return { type: 'type', name: name, value: value };
};
var Literal = function Literal(value) {
  return { type: 'literal', value: value };
};
var Exact = function Exact(value) {
  return { type: 'exact', value: value };
};
var Optional = function Optional(child) {
  return { type: 'optional', child: child };
};
var Array = function Array(child) {
  return { type: 'array', child: child };
};
var Tuple = function Tuple(children) {
  return { type: 'tuple', children: children };
};
var Record = function Record(fields) {
  return { type: 'record', fields: fields };
};
var Map = function Map(child) {
  return { type: 'map', child: child };
};
var Union = function Union(children) {
  return { type: 'union', children: children };
};
var Intersection = function Intersection(children) {
  return { type: 'intersection', children: children };
};

exports.default = {
  Mixed: Mixed,
  Boolean: Boolean,
  Null: Null,
  Number: Number,
  String: String,
  Declaration: Declaration,
  Type: Type,
  Literal: Literal,
  Exact: Exact,
  Optional: Optional,
  Array: Array,
  Tuple: Tuple,
  Record: Record,
  Map: Map,
  Union: Union,
  Intersection: Intersection
};