'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var INDENT = '  ';

var indent = function indent(line, depth) {
  return '' + _lodash2.default.repeat(INDENT, depth) + line;
};

var gengensym = function gengensym() {
  var cache = {};
  return function () {
    var prefix = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'v';

    cache[prefix] = cache[prefix] || 0;
    return '' + prefix + cache[prefix]++;
  };
};

exports.default = {
  indent: indent,
  gengensym: gengensym
};